/*
 *	OSU Research Computing					Trillium
 *	Copyright 1992 The Ohio State University
 *	GDB
 *
 *	$Log:	stoi.c,v $
 * Revision 6.1  96/11/23  19:58:18  nevin
 * Ohio Release
 * 
 * Revision 6.0  96/02/29  13:48:51  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:57:10  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  10:57:07  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:35:07  gdburns
 * Ohio Release
 * 
 * Revision 2.2  92/04/30  14:40:51  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.1  92/01/20  19:12:41  gdburns
 * I am now a portable int4 program.
 * 
 *	Functions:	- converts decimal or hexadecimal string to integer
 */

#include <portable.h>

int4
stoi(s)

unsigned char		*s;

{
	int4  		base;			/* base of digits */
	int4  		i;			/* result */
	int4  		sign;			/* sign of result */
	int		valid;			/* valid digit? */
	unsigned char	c;			/* current digit */

	if (s[0] == '-') {
		sign = -1;
		s++;
	} else {
		sign = 1;
	}

	if ((s[0] == '0') && ((s[1] == 'x') || (s[1] == 'X'))) {
		base = 16;
		s += 2;
	} else {
		base = 10;
	}

	i = 0;
	valid = 1;

	while (*s && valid) {
		c = *s;

		if ((c >= '0') && (c <= '9')) {
			i = (i * base) + (c - '0');
		}

		else if (base == 16) {

			if ((c >= 'a') && (c <= 'f')) {
				i = (i * base) + (c - 'a' + 0xa);
			}

			else if ((c >= 'A') && (c <= 'F')) {
				i = (i * base) + (c - 'A' + 0xA);
			}

			else {
				valid = 0;
			}
		} else {
			valid = 0;
		}

		s++;
	}

	i *= sign;

	return(i);
}
