/*
 *	Ohio Trollius
 *	Copyright 1996 The Ohio	State University
 *	RBD/NJN
 *
 *	$Id: testall_f.c,v 6.1 96/11/22 13:44:37 nevin Rel $
 *
 *	Function:	- MPI_Testall F77 wrapper
 */

#include <lam_config.h>

#include <errno.h>
#include <stdlib.h>

#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_testall_(c,	rqs, f,	sts, ierr)

int			*c, *rqs, *f, *sts, *ierr;

{
	MPI_Request	*reqs;
	MPI_Status	*stats;
	int		i;

	reqs = (MPI_Request *) malloc((unsigned) (*c) *	sizeof(MPI_Request));
	if (reqs == 0) {
		*ierr =	lam_mkerr(MPI_ERR_OTHER, errno);
		return;
	}
	stats =	(MPI_Status *) malloc((unsigned) (*c) *	sizeof(MPI_Status));
	if (stats == 0)	{
		free((char *) reqs);
		*ierr =	lam_mkerr(MPI_ERR_OTHER, errno);
		return;
	}
	for (i = 0; i <	*c; ++i)
		reqs[i]	= GETHDL(rqs[i]);

	*ierr =	MPI_Testall(*c,	reqs, f, stats);
	if ((*ierr == MPI_SUCCESS) && (*f != 0)) {
		for (i = 0; i <	*c; ++i) {
			lam_C2F_stat(stats + i,	sts);
			sts[6] = -1;
			sts += 7;
			if (reqs[i] == MPI_REQUEST_NULL) {
				lam_F_typefree(rqs[i]);
				rqs[i] = -1;
			}
		}
	}
	free((char *) reqs);
	free((char *) stats);
}
