/*
 *	Ohio Trollius
 *	Copyright 1996 The Ohio	State University
 *	RBD/NJN
 *
 *	$Id: waitany_f.c,v 6.1 96/11/22 13:44:37 nevin Rel $
 *
 *	Function:	- MPI_Waitany F77 wrapper
 */

#include <lam_config.h>

#include <errno.h>
#include <stdlib.h>

#include <mpi.h>
#include <MPISYS.h>
#include <mpisys.h>

void
mpi_waitany_(c,	rqs, idx, st, ierr)

int			*c, *rqs, *idx,	*st, *ierr;

{
	MPI_Request	*reqs;
	MPI_Status	stat;
	int		i;

	reqs = (MPI_Request *) malloc((unsigned) (*c) *	sizeof(MPI_Request));
	if (reqs == 0) {
		*ierr =	lam_mkerr(MPI_ERR_OTHER, errno);
		return;
	}

	for (i = 0; i <	*c; ++i) reqs[i] = GETHDL(rqs[i]);

	*ierr =	MPI_Waitany(*c,	reqs, idx, &stat);
	if (*ierr == MPI_SUCCESS) {
		lam_C2F_stat(&stat, st);
		st[6] =	-1;
		if (reqs[*idx] == MPI_REQUEST_NULL) {
			lam_F_typefree(rqs[*idx]);
			rqs[*idx] = -1;
		}

		++(*idx);
	}

	free((char *) reqs);
}
